﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Alarmeinheit																		//
//  _________________________________                                                   //
//                                                                                      //
//  Copyright (c) 2024 Reimar Grasbon                                                   //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "TypeDefs.h"
#include "Cy4Service.h"
#include "Cy4Message.h"

//////////////////////////////////////////////////////////////////////////////////////////
//  Typen  ///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
typedef enum									// Zustände der Alarmeinheit:
{   ALARMUNIT_STATE_STARTED              = 0,	// · Alarmeinheit gestartet
	ALARMUNIT_STATE_DISABLED             = 1,	// · Alarmeinheit abgeschaltet
	ALARMUNIT_STATE_ACTIVATION_ANNOUNCED = 2,	// · Aktivierung der Alarmeinheit angekündigt
	ALARMUNIT_STATE_ACTIVATED            = 3,	// · Alarmeinheit aktiviert
	ALARMUNIT_STATE_TRIGGERING_ANNOUNCED = 4,	// · Alarmauslösung angekündigt
	ALARMUNIT_STATE_TRIGGERED            = 5,	// · Alarm ausgelöst
	ALARMUNIT_STATE_UNKNOWN              = 6	// · Zustand unbekannt
} AlarmUnitState;

//////////////////////////////////////////////////////////////////////////////////////////
//  Cy4-Dienst Anfrage-Bearbeiter  ///////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void    OnALARMUNIT_StateBroadcast(const Cy4Service*, Cy4Message*);

//////////////////////////////////////////////////////////////////////////////////////////
//  Funktionen  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
AlarmUnitState	ALARMUNIT_State(void);
void	        ALARMUNIT_Deactivate(void);
void	        ALARMUNIT_Activate(UInt08);
void	        ALARMUNIT_Toggle(UInt08);
void	        ALARMUNIT_Trigger(UInt08, const char*);

//////////////////////////////////////////////////////////////////////////////////////////
//  Prozessaufrufe  //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void    ALARMUNIT_Startup(void);
void    ALARMUNIT_Proceed(void);
void    ALARMUNIT_Shutdown(void);

//////////////////////////////////////////////////////////////////////////////////////////

